package freedom.server.model;

import java.util.Date;

/**
 * Cxg\NX
 * 
 * @author ikumi
 * @version $Id: Event.java,v 1.10 2006/07/26 11:00:19 ikumi Exp $
 */
public class Event {
	private int id;
	private String name; // Cxg
	private String outline; // Tv
	private String subjoinder; // ǋL
	private int requiredDays; // Kv
	private int requiredHours; // Kv
	private int requiredMinutes; // Kv
	private Date replyDeadline; // \͊
	private int monthLimit;
	private int dayLimit;
	private String hostName; // 
	private String hostAddress; // [AhX
	private String participantAddress; // Q\҃[AhX
	private boolean isCancel; // CxgLZɂȂǂ
	private Date deleteDeadline; // Cxg폜

	public Event() {
	}

	public Event(String name, String outline, int requiredDays,
			int requiredHours, int requiredMinutes, Date replyDeadline,
			String hostName, String hostAddress, String participantAddress) {
		this.name = name;
		this.outline = outline;
		this.requiredDays = requiredDays;
		this.requiredHours = requiredHours;
		this.requiredMinutes = requiredMinutes;
		this.replyDeadline = replyDeadline;
		this.hostName = hostName;
		this.hostAddress = hostAddress;
		this.participantAddress = participantAddress;
	}

	public Event(int id, String name, String outline, int requiredDays,
			int requiredHours, int requiredMinutes, Date replyDeadline,
			String hostName, String hostAddress, String participantAddress) {
		this.id = id;
		this.name = name;
		this.outline = outline;
		this.requiredDays = requiredDays;
		this.requiredHours = requiredHours;
		this.requiredMinutes = requiredMinutes;
		this.replyDeadline = replyDeadline;
		this.hostName = hostName;
		this.hostAddress = hostAddress;
		this.participantAddress = participantAddress;
		// this.isCancel = isCancel;
	}

	public Event(int id, String name, String outline, String subjoinder,
			int requiredDays, int requiredHours, int requiredMinutes,
			Date replyDeadline, String hostName, String hostAddress,
			String participantAddress, boolean isCancel) {
		this.id = id;
		this.name = name;
		this.outline = outline;
		this.subjoinder = subjoinder;
		this.requiredDays = requiredDays;
		this.requiredHours = requiredHours;
		this.requiredMinutes = requiredMinutes;
		this.replyDeadline = replyDeadline;
		this.hostName = hostName;
		this.hostAddress = hostAddress;
		this.participantAddress = participantAddress;
		this.isCancel = isCancel;
	}

	public int getId() {
		return id;
	}

	public void setId(int id) {
		this.id = id;
	}

	/***************************************************************************
	 * public Date getLimitDate() { return limitDate; }
	 * 
	 * public void setLimitDate(Date limitDate) { this.limitDate = limitDate; }
	 **************************************************************************/

	public int getDayLimit() {
		return dayLimit;
	}

	public void setDayLimit(int dayLimit) {
		this.dayLimit = dayLimit;
	}

	public int getMonthLimit() {
		return monthLimit;
	}

	public void setMonthLimit(int monthLimit) {
		this.monthLimit = monthLimit;
	}

	public int getRequiredMinutes() {
		return requiredMinutes;
	}

	public void setRequiredMinutes(int requiredMinutes) {
		this.requiredMinutes = requiredMinutes;
	}

	public String getHostAddress() {
		return hostAddress;
	}

	public void setHostAddress(String hostAddress) {
		this.hostAddress = hostAddress;
	}

	public String getHostName() {
		return hostName;
	}

	public void setHostName(String hostName) {
		this.hostName = hostName;
	}

	public String getName() {
		return name;
	}

	public void setName(String name) {
		this.name = name;
	}

	public String getOutline() {
		return outline;
	}

	public void setOutline(String outline) {
		this.outline = outline;
	}

	public String getParticipantAddress() {
		return participantAddress;
	}

	public void setParticipantAddress(String participantAddress) {
		this.participantAddress = participantAddress;
	}

	public int getRequiredDays() {
		return requiredDays;
	}

	public void setRequiredDays(int requiredDay) {
		this.requiredDays = requiredDay;
	}

	public int getRequiredHours() {
		return requiredHours;
	}

	public void setRequiredHours(int requiredHour) {
		this.requiredHours = requiredHour;
	}

	public String getSubjoinder() {
		return subjoinder;
	}

	public void setSubjoinder(String subjoinder) {
		this.subjoinder = subjoinder;
	}

	public boolean getIsCancel() {
		return isCancel;
	}

	public void setIsCancel(boolean isCancel) {
		this.isCancel = isCancel;
	}

	public Date getReplyDeadline() {
		return replyDeadline;
	}

	public void setReplyDeadline(Date replyDeadline) {
		this.replyDeadline = replyDeadline;
	}

	public Date getDeleteDeadline() {
		return deleteDeadline;
	}

	public void setDeleteDeadline(Date deleteDeadline) {
		this.deleteDeadline = deleteDeadline;
	}
}
