package freedom.server.transaction;

import java.sql.ResultSet;
import java.util.Date;

import freedom.server.DBConnector;
import freedom.server.model.Event;

/**
 * CxgDB擾邽߂̃NX
 * 
 * @author ikumi
 * @version $Id: EventManager.java,v 1.13 2006/07/27 22:05:43 ikumi Exp $
 */
public class EventManager {

	public Event getEvent(int eventID) throws Exception {
		Event event = null;

		String sql = "SELECT * FROM event where id=" + eventID;
		DBConnector con = DBConnector.getConnector();
		ResultSet rs = con.executeQuery(sql);

		if (rs.next()) {
			event = new Event(rs.getInt("id"), rs.getString("name"), rs
					.getString("outline"), rs.getString("subjoinder"), rs
					.getInt("required_day"), rs.getInt("required_hour"), rs
					.getInt("required_minute"), rs.getDate("reply_deadline"),
					rs.getString("host_name"), rs.getString("host_address"), rs
							.getString("participant_address"), rs
							.getBoolean("iscancel"));
		}
		con.finish();

		return event;
	}

	/**
	 * Cxg擾
	 * 
	 * @param eventID
	 * @return Event
	 * @throws Exception
	 */
	public Event getEventById(int eventID) throws Exception {
		Event event = null;

		String sql = "SELECT * FROM event WHERE id = '" + eventID + "'";
		DBConnector con = DBConnector.getConnector();
		ResultSet rs = con.executeQuery(sql);

		if (rs.next()) {
			event = new Event(rs.getString("name"), rs.getString("outline"), rs
					.getInt("required_day"), rs.getInt("required_hour"), rs
					.getInt("required_minute"), rs.getDate("reply_deadline"),
					rs.getString("host_name"), rs.getString("host_address"), rs
							.getString("participant_address"));
		}
		con.finish();

		return event;
	}

	/**
	 * Cxgo^
	 * 
	 * @param event
	 * @throws Exception
	 */
	public void register(Event event) throws Exception {
		DBConnector con = DBConnector.getConnector(true);

		String sql = "INSERT INTO event(id, name, host_name, host_address, participant_address, outline,"
				+ "reply_deadline, required_day, required_hour, required_minute) VALUES ('"
				+ event.getId()
				+ "','"
				+ event.getName()
				+ "','"
				+ event.getHostName()
				+ "','"
				+ event.getHostAddress()
				+ "','"
				+ event.getParticipantAddress()
				+ "','"
				+ event.getOutline()
				+ "','"
				+ event.getReplyDeadline()
				+ "','"
				+ event.getRequiredDays()
				+ "','"
				+ event.getRequiredHours()
				+ "','" + event.getRequiredMinutes() + "')";
		con.executeUpdate(sql);
		con.finish();
	}

	/**
	 * CxgXV
	 * 
	 * @param event
	 * @throws Exception
	 */
	public void update(Event event) throws Exception {
		DBConnector con = DBConnector.getConnector(true);
		String sql = "UPDATE event SET name = '" + event.getName()
				+ "', host_name='" + event.getHostName() + "', host_address='"
				+ event.getHostAddress() + "', participant_address='"
				+ event.getParticipantAddress() + "', outline='"
				+ event.getOutline() + "', reply_deadline='"
				+ event.getReplyDeadline() + "', required_day='"
				+ event.getRequiredDays() + "', required_hour='"
				+ event.getRequiredHours() + "', required_minute='"
				+ event.getRequiredMinutes() + "' WHERE id='" + event.getId()
				+ "'";
		con.executeUpdate(sql);
		con.finish();
	}

	public void registSubjoinder(int eventID, String subjoinder)
			throws Exception {
		DBConnector con = DBConnector.getConnector(true);

		String sql = "UPDATE event SET subjoinder = '" + subjoinder
				+ "' WHERE id = '" + eventID + "';";
		con.executeUpdate(sql);
		con.finish();
	}

	/**
	 * Cxg폜
	 * 
	 * @param eventID
	 * @throws Exception
	 */
	public void delete(int eventID) throws Exception {
		DBConnector con = DBConnector.getConnector(true);

		String sql = "DELETE FROM event WHERE id = '" + eventID + "'";
		con.executeUpdate(sql);
		con.finish();
	}

	/**
	 * event.id̎̒l擾
	 * 
	 * @return
	 * @throws Exception
	 */
	public int getNextID() throws Exception {
		int id = -1;

		String sql = "SELECT nextval('event_id_seq') AS nextId";
		DBConnector con = DBConnector.getConnector();
		ResultSet rs = con.executeQuery(sql);

		if (rs.next()) {
			id = rs.getInt("nextId");
		}
		con.finish();

		return id;
	}

	/**
	 * Cxg~̐ݒ
	 * 
	 * @param eventId
	 * @throws Exception
	 */
	public void cancel(int eventId, Date deleteDeadline) throws Exception {
		DBConnector con = DBConnector.getConnector(true);

		String sql = "UPDATE event SET isCancel = true"
				+ ", delete_deadline = '" + deleteDeadline + "' WHERE id = '"
				+ eventId + "'";

		con.executeUpdate(sql);
		System.out.println(sql);
		con.finish();
	}

	/**
	 * CxgĐ̐ݒ
	 * 
	 * @param eventId
	 * @throws Exception
	 */
	public void revival(int eventId) throws Exception {
		DBConnector con = DBConnector.getConnector(true);

		String sql = "UPDATE event SET isCancel = false WHERE id = '" + eventId
				+ "'";
		con.executeUpdate(sql);
		con.finish();
	}

	/**
	 * ̃AhX擾
	 * 
	 * @param eventId
	 * @return hostAddress
	 * @throws Exception
	 */
	public String getHostAddress(int eventId) throws Exception {
		String sql = "SELECT host_address FROM event WHERE id='" + eventId
				+ "'";
		DBConnector con = DBConnector.getConnector();
		ResultSet rs = con.executeQuery(sql);
		String hostAddress = null;

		if (rs.next()) {
			hostAddress = rs.getString("host_address");
		}
		con.finish();

		return hostAddress;
	}

	/**
	 * ~Ԃ擾
	 * 
	 * @param eventId
	 * @return hostAddress
	 * @throws Exception
	 */
	public boolean getIsCancel(int eventId) throws Exception {
		String sql = "SELECT iscancel FROM event WHERE id='" + eventId + "'";
		DBConnector con = DBConnector.getConnector();
		ResultSet rs = con.executeQuery(sql);
		boolean isCancel = false;

		if (rs.next()) {
			isCancel = rs.getBoolean("iscancel");
		}
		con.finish();

		return isCancel;
	}

	/**
	 * 񓚊擾
	 * 
	 * @param eventId
	 * @return hostAddress
	 * @throws Exception
	 */
	public Date getReplyDeadline(int eventId) throws Exception {
		String sql = "SELECT reply_deadline FROM event WHERE id='" + eventId
				+ "'";
		DBConnector con = DBConnector.getConnector();
		ResultSet rs = con.executeQuery(sql);
		Date replyDeadline = null;

		if (rs.next()) {
			replyDeadline = rs.getDate("reply_deadline");
		}
		con.finish();

		return replyDeadline;
	}

}
