package freedom.server.transaction;

import java.sql.ResultSet;
import java.util.ArrayList;
import java.util.List;

import freedom.server.DBConnector;
import freedom.server.model.Participant;

/**
 * Q\҂DB擾邽߂̃NX
 * 
 * @author ikumi
 * @version $Id: ParticipantManager.java,v 1.8 2006/07/27 19:19:36 ikumi Exp $
 */
public class ParticipantManager {

	/**
	 * Q\҂o^
	 * 
	 * @param participant
	 * @throws Exception
	 */
	public void registParticipant(Participant participant) throws Exception {
		DBConnector con = DBConnector.getConnector(true);

		String sql = "INSERT INTO participant(name, mailaddress, event_id) VALUES ('"
				+ participant.getName()
				+ "','"
				+ participant.getMailaddress()
				+ "','" + participant.getEventID() + "')";
		con.executeUpdate(sql);
		con.finish();
	}

	public void registParticipant(String mailAddress, int eventID)
			throws Exception {
		DBConnector con = DBConnector.getConnector(true);

		String sql = "INSERT INTO participant(mailaddress, event_id) VALUES ('"
				+ mailAddress + "','" + eventID + "')";
		con.executeUpdate(sql);
		con.finish();
	}

	public void updateParticipant(Participant participant, String mailAddress,
			int eventID) throws Exception {
		DBConnector con = DBConnector.getConnector(true);

		String sql = "UPDATE participant SET name = '" + participant.getName()
				+ "' WHERE mailaddress = '" + mailAddress
				+ "' AND event_id = '" + eventID + "';";
		con.executeUpdate(sql);
		con.finish();
	}

	public Participant getParticipant(int participantID) throws Exception {
		Participant participant = null;

		String sql = "SELECT * FROM participant where id = '" + participantID
				+ "';";
		DBConnector con = DBConnector.getConnector();
		ResultSet rs = con.executeQuery(sql);

		if (rs.next()) {
			participant = new Participant(rs.getInt("id"),
					rs.getString("name"), rs.getString("mailaddress"), rs
							.getInt("priority"),
					rs.getBoolean("isparticipate"), rs.getInt("event_id"));
		}
		con.finish();

		return participant;
	}

	public Participant getParticipant(String mailAddredd, int eventID)
			throws Exception {
		Participant participant = null;

		String sql = "SELECT * FROM participant WHERE mailaddress = '"
				+ mailAddredd + "' AND event_id = '" + eventID + "';";
		DBConnector con = DBConnector.getConnector();
		ResultSet rs = con.executeQuery(sql);

		if (rs.next()) {
			participant = new Participant(rs.getInt("id"),
					rs.getString("name"), rs.getString("mailaddress"), rs
							.getInt("priority"),
					rs.getBoolean("isparticipate"), rs.getInt("event_id"));
		}
		con.finish();

		return participant;
	}

	public List getParticipantList(int eventID) throws Exception {
		List participantList = new ArrayList();

		String sql = "SELECT * FROM participant WHERE event_id = '" + eventID
				+ "';";
		System.out.println(sql);
		DBConnector con = DBConnector.getConnector();
		ResultSet rs = con.executeQuery(sql);

		while (rs.next()) {
			if (rs.getString("name") != null) {
				Participant participant = new Participant(rs.getInt("id"), rs
						.getString("name"), rs.getString("mailaddress"), rs
						.getInt("priority"), rs.getBoolean("isparticipate"), rs
						.getInt("event_id"));
				participantList.add(participant);
			}
		}
		con.finish();

		return participantList;
	}

	/**
	 * oo^
	 * 
	 * @param participantID
	 * @param isParticipate
	 * @throws Exception
	 */
	public void registParticipation(int participantID, boolean isParticipate,
			String name) throws Exception {
		DBConnector con = DBConnector.getConnector(true);

		String sql = "UPDATE participant SET isparticipate = '" + isParticipate
				+ "', name = '" + name + "' WHERE id = '" + participantID
				+ "';";
		con.executeUpdate(sql);
		con.finish();
	}

	/**
	 * Q\҂폜
	 * 
	 * @param participantID
	 * @throws Exception
	 */
	public void delete(int participantID) throws Exception {
		DBConnector con = DBConnector.getConnector(true);

		String sql = "DELETE FROM participant WHERE id = '" + participantID
				+ "'";
		con.executeUpdate(sql);
		con.finish();
	}

	/**
	 * Ă
	 * 
	 * @param args
	 */
	public static void main(String[] args) {
		// Participant p = new Participant("RcY", "yamada@hoge.co.jp", 1);
		// ParticipantManager pm = new ParticipantManager();
		try {
			// pm.register(p);
			// pm.delete(2);
			// System.out.println(pm.getParticipant(2).getName());
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
}
