package freedom.struts.event.action;

import java.util.Calendar;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.struts.action.Action;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.action.ActionMessage;
import org.apache.struts.action.ActionMessages;
import org.apache.struts.action.DynaActionForm;

public class CreateEventAction extends Action {
	public ActionForward execute(ActionMapping mapping, ActionForm actionForm,
			HttpServletRequest request, HttpServletResponse response)
			throws Exception {

		DynaActionForm daf = (DynaActionForm) actionForm;
		ActionMessages errors = new ActionMessages();

		// KvAőI΂ĂȂӏ邩ׂ

		// 񓚊ȍ~ł邩ׂ
		Calendar cal = Calendar.getInstance();
		if (Integer.parseInt(daf.get("dayLimit").toString()) <= cal
				.get(Calendar.DATE)
				&& Integer.parseInt(daf.get("monthLimit").toString()) <= cal
						.get(Calendar.MONTH) + 1) {
			errors.add(ActionMessages.GLOBAL_MESSAGE, new ActionMessage(
					"errors.limitBeforeToday"));
			saveErrors(request, errors);

			return mapping.findForward("error");
		}

		// ⎞Ԃ0JnƏItɂȂĂG[\
		int canBH = Integer.parseInt(daf.get("candidateBeginningHour")
				.toString());
		int canBM = Integer.parseInt(daf.get("candidateBeginningMinute")
				.toString());
		int canEH = Integer.parseInt(daf.get("candidateEndingHour").toString());
		int canEM = Integer.parseInt(daf.get("candidateEndingMinute")
				.toString());
		if ((canEH - canBH < 0) || (canEH - canBH == 0 && canEM - canBM <= 0)) {
			errors.add(ActionMessages.GLOBAL_MESSAGE, new ActionMessage(
					"errors.wrongCandidateTime"));
			saveErrors(request, errors);

			return mapping.findForward("error");
		}

		// KvԂ24:30I΂ĂG[bZ[W\
		if (daf.get("requiredHours").toString().equals("24")
				&& daf.get("requiredMinutes").toString().equals("30")) {
			errors.add(ActionMessages.GLOBAL_MESSAGE, new ActionMessage(
					"errors.requiredTimeOver"));
			saveErrors(request, errors);

			return mapping.findForward("error");
		}

		return mapping.findForward("success");
	}

}
