package freedom.struts.participant.action;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.struts.action.Action;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;

import freedom.server.model.Event;
import freedom.server.model.Participant;
import freedom.server.transaction.EventManager;
import freedom.server.transaction.ParticipantManager;

public class ConfirmQuestionAction extends Action {
	public ActionForward execute(ActionMapping mapping, ActionForm actionForm,
			HttpServletRequest request, HttpServletResponse response)
			throws Exception {
		int eventID = Integer.parseInt(request.getSession().getAttribute(
				"eventID").toString());
		String mailAddress = request.getSession().getAttribute("mailAddress")
				.toString();

		EventManager eventManager = new EventManager();
		Event event = eventManager.getEvent(eventID);

		ParticipantManager participantManager = new ParticipantManager();
		Participant participant = participantManager.getParticipant(
				mailAddress, eventID);

		request.setAttribute("event", event);
		request.setAttribute("participant", participant);
		return mapping.findForward("success");
	}
}
