package freedom.struts.participant.action;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.struts.action.Action;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;

import freedom.server.model.Participant;
import freedom.server.transaction.ParticipantManager;

public class InputQuestionAction extends Action {
	public ActionForward execute(ActionMapping mapping, ActionForm actionForm,
			HttpServletRequest request, HttpServletResponse response)
			throws Exception {
		String mailAddress = request.getSession().getAttribute("mailAddress")
				.toString();
		int eventID = Integer.parseInt(request.getSession().getAttribute(
				"eventID").toString());

		ParticipantManager participantManager = new ParticipantManager();
		Participant participant = participantManager.getParticipant(
				mailAddress, eventID);

		String name = "";
		if (participant.getName() != null) {
			name = participant.getName();
		}

		request.getSession().setAttribute("name", name);
		return mapping.findForward("success");
	}
}
