package freedom.struts.participant.action;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.struts.action.Action;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.action.DynaActionForm;

import freedom.mail.FreedomMail;
import freedom.server.FreedomConfig;
import freedom.server.model.Event;
import freedom.server.model.Participant;
import freedom.server.transaction.EventManager;
import freedom.server.transaction.ParticipantManager;
import freedom.server.transaction.ScheduleManager;

public class RegistScheduleAction extends Action {
	public ActionForward execute(ActionMapping mapping, ActionForm actionForm,
			HttpServletRequest request, HttpServletResponse response)
			throws Exception {
		DynaActionForm form = (DynaActionForm) actionForm;
		String[] conviniences = form.getStrings("convinienceList");
		int eventID = Integer.parseInt(request.getSession().getAttribute(
				"eventID").toString());
		String participantAddress = request.getSession().getAttribute(
				"mailAddress").toString();

		ParticipantManager pm = new ParticipantManager();
		ScheduleManager scheduleManager = new ScheduleManager();
		EventManager eventManager = new EventManager();

		Event event = eventManager.getEvent(eventID);
		request.setAttribute("event", event);

		if (!event.getIsCancel()) {
			// DBɎQ\҂o^

			Participant person = new Participant(form.getString("name"), form
					.getString("address"), eventID);
			pm.updateParticipant(person, request.getSession().getAttribute(
					"mailAddress").toString(), eventID);

			System.out.println("RegistSchedule: mailAddress: "
					+ participantAddress);
			System.out.println("RegistSchedule: eventID: " + eventID);
			Participant newcommer = pm.getParticipant(participantAddress,
					eventID);
			int userID = newcommer.getID();

			System.out.println("RegistScheduleAction: userID: " + userID);
			System.out.println("RegistScheduleAction: userName: "
					+ person.getName());

			// ͂ꂽ\DBɓo^
			scheduleManager.updateSchedule(userID, eventID, conviniences);

			// Ƀ[𑗂
			String hostContent = form.getString("name") + "񂪗\XV܂B\n\r"
					+ form.getString("name") + "񂩂̃bZ[WF\n\r"
					+ form.getString("message") + "\n\r" + "\n\r"
					+ "̃AhX\肪mFł܂B\n\r" + FreedomConfig.BASE_URL
					+ "hostMenu.do?eventID=" + eventID;
			FreedomMail.sendMail(event.getHostAddress(), form.getString("name")
					+ "񂪗\XV܂B", hostContent, false);

			// Q\҂Ƀ[𑗂
			String participantContent = "\̍XV܂B\n\r"
					+ "bZ[WF\n\r"
					+ form.getString("message")
					+ "\n\r"
					+ "̃AhXmFł܂B\n\r"
					+ FreedomConfig.BASE_URL
					+ "scheduleList.do?eventID="
					+ eventID
					+ "&address="
					+ request.getSession().getAttribute("mailAddress")
							.toString();
			FreedomMail.sendMail(participantAddress, "\̍XV܂",
					participantContent, false);

			return mapping.findForward("success");
		} else {
			return mapping.findForward("fail");
		}
	}
}
