/**
 * DBConnector.java
 *
 * Copyright (c) 2002 Boxed-Economy Project. All right reserved. 
 */
package freedom.server;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;

import javax.naming.NamingException;
import javax.servlet.ServletContext;
import javax.sql.DataSource;

/**
 * DBɐڑ邽߂ConnectorłBjava.sql.connectorbvSQLsC^[tF[X܂B
 * ̃NX̃CX^X̎擾getNewConnector()ɂčsĂB
 * 
 * 2003/09/02 ڑ`ؒf܂ł̎dlύX܂Bȉ̎菇ŁiOjĂяo܂B PDڑE擾 DBConnector con =
 * DBConnector.getConnector(); ŁAv[iɊJĂjConnection擾܂B
 * AConnection݂Ȃ΁AVɐĕԂ܂B
 * 
 * QD executeQuery,executeUpdate,getPreparedStatement
 * ȂǂősȂ܂BAR~bg͂܂ RDR~bgi̓[obNj Q̑̃R~bgA[obNsȂ܂B SDؒfE
 * con.finish() finish()\bhɂConnection܂BConnectionؒf킯ł͂Ȃ
 * ̂ŒӂĂB܂A̐ؒfɎIcommitsȂ܂B̂߁AR vZX͕KLqKv͂܂
 * 
 * 
 * 2004/04/24 f[^\[XiconnectionPooljgȂ悤ɉĂ݂܂B
 * USE_DATASOURCEB݂͂̐ݒɂȂĂ܂B 2004/04/27 L̐ݒ߂܂. 2004/04/28
 * sԂ𑪒肷邽߂̋@\ǉ WATCHB 2004/05/08
 * ServletContextɃOo͂̂ŁAsetDatasource\bhinitialize
 * AServletContextǉ 2004/05/08 SelectŃgUNVJĂ̂ŁA𖳂߂
 * getConnectorɈ^悤ɂ܂B
 * 
 * @author rx78g
 * @version $Id: DBConnector.java,v 1.4 2006/07/19 19:08:58 ikumi Exp $
 */
public class DBConnector {
	private Statement statement;
	private ResultSet rs;

	// private static DataSource datasource = null;
	private static boolean isInitialized = false;
	private static ServletContext context = null;

	/**
	 * ServletContextDataSourceݒ肷郁\bhłBnull̏ꍇɂ̂ݐݒ肳܂B
	 * ʏDataSource̎dg݂Servlet𗘗p邱ƂɂȂĂ܂̂ Ƀ\bhpӂāAActionpxɌĂт܂B
	 * 
	 * @param ds
	 */
	public static void initialize(DataSource ds, ServletContext ctx)
			throws NamingException {
		// f[^\[Xݒ肵܂íA܂j
		// Context namingContext = new InitialContext();
		// datasource = (DataSource)
		// namingContext.lookup("java:comp/env/jdbc/ircdb");
		// datasource = ds;
		isInitialized = true;
		context = ctx;
	}

	public static boolean isInitialized() {
		return isInitialized;
	}

	/**
	 * ڑς݂Connectorv[擾Ԃstatic\bhłB O͂̃\bhĂԂ悤ɂĂB
	 * 
	 * @return DBConnector
	 */
	public static DBConnector getConnector(boolean update) throws Exception {
		return new DBConnector(update);
	}

	/**
	 * ftHgłfalseiSELECTȂǂsȂjƂĐݒ肵܂B
	 * 
	 * @return
	 * @throws Exception
	 */
	public static DBConnector getConnector() throws Exception {
		return getConnector(false);
	}

	/**
	 * RXgN^łBIɂĂ΂Ȃ悤ɂ܂B CjVCYĂȂꍇ͂̃NX̃CX^Xϐ擾Đڑ܂B
	 * ͂܂ŃfobOpłBӁI
	 */
	private DBConnector(boolean update) throws Exception {
		/*
		 * if (isInitialized && USE_DATASOURCE) { conn =
		 * datasource.getConnection(); } else { Class.forName(driverName); conn =
		 * DriverManager.getConnection(dbName, user, password); }
		 */
		// if(dbConnection.get() == null) {
		// log("DBConnector: f[^\[XDBRlNV擾AXbhϐɑ܂");
		// dbConnection.set(datasource.getConnection());
		// }
		// 
		// conn = (Connection) dbConnection.get();
		// log("DBConnector: DBRlN^[𐶐܂Bupdate=" + update);
		// DBConnection.currentConnection().setAutoCommit(!update);
	}

	/**
	 * InsertUpdateȂǂSQLs܂B OꍇArollbacksȂŐؒfAO͓]܂B
	 */
	public void executeUpdate(String sqlString) throws Exception {
		try {
			if (DBConnection.currentConnection().getAutoCommit()) { // R~bgɂȂĂꍇAG[Ԃ܂B
				// throw new IRCException("SELECT
				// ^ConnectionUpdate悤Ƃ܂B"+sqlString);
			}
			statement = DBConnection.currentConnection().createStatement();
			statement.executeUpdate(sqlString);
			statement.close();
			statement = null;
		} catch (SQLException e) {
			System.out.println(sqlString);
			DBConnection.currentConnection().rollback();
			// log("DBConnector.executeUpdate(): DBRlNVؒf܂");
			DBConnection.currentConnection().close();
			throw e;
		}
	}

	/**
	 * Selects܂B OꍇArollbacksȂŁAؒf܂B
	 */
	public ResultSet executeQuery(String sqlString) throws Exception {
		try {

			long now = System.currentTimeMillis();// sJniOpj
			// log("DBConnector#executeQuery start " + now);

			// Xe[gg쐬
			statement = DBConnection.currentConnection().createStatement(); // SQLsXe[gg̍쐬
			boolean result = statement.execute(sqlString);

			long end = System.currentTimeMillis();

			// Oo͂
			// executeQuery\bȟĂяõ\bh{sSQL{Ԃ̌`ŏo
			StackTraceElement stack[] = (new Throwable()).getStackTrace();// Op̃X^bNg[X
			StackTraceElement frame = stack[1];// ̃\bh̒ڂ̌Ăяo
			String methodName = frame.getClassName() + "#"
					+ frame.getMethodName() + "(" + frame.getLineNumber() + ")";
			log("** Execution SQL at " + methodName + " [SQL= " + sqlString
					+ " ] [ExecuteTime: " + (end - now) + "ms]");
			if (result) {
				rs = statement.getResultSet();
				return rs;
			} else {
				return null;
			}

		} catch (SQLException e) {
			System.out.println(sqlString);
			DBConnection.currentConnection().rollback();
			log("DBConnector.executeQuery(): DBRlNVؒf܂");
			DBConnection.currentConnection().close();
			throw e;
		}
	}

	/**
	 * PreparedStatementԂ܂Bp[^[HŎw肵A̐A邱Ƃ
	 * płPreparedStatement͂ƈႤrpkxsꍇɗLłB iڍׂ͂`ohQƁj
	 * 
	 * @throws ClassNotFoundException
	 * 
	 * @deprecated
	 */
	public PreparedStatement getPreparedStatement(String sql)
			throws SQLException, ClassNotFoundException {
		return DBConnection.currentConnection().prepareStatement(sql);
	}

	/**
	 * PreparedStatementԂ܂Bp[^[HŎw肵A̐A邱Ƃ
	 * płPreparedStatement͂ƈႤrpkxsꍇɗLłB iڍׂ͂`ohQƁj
	 * 
	 * @param sql
	 * @return
	 * @throws Exception
	 */
	public FreedomPreparedStatement getIRCPreparedStatement(String sql)
			throws Exception {
		return new FreedomPreparedStatement(sql, this);
	}

	/**
	 * getPreparedStatement̎ŝ߂ɗpӂ\bhłB
	 * protectedɂ邱ƂŁApbP[WÕANZX܂
	 * 
	 * @return
	 */
	protected Connection getConnection() throws SQLException {
		return DBConnection.currentConnection();
	}

	/**
	 * R~bg𖾎IɌĂяo܂B SĂ̕ύX𔽉fꍇɌĂяo܂B
	 */
	public void commit() throws SQLException {
		DBConnection.currentConnection().commit();
	}

	/**
	 * [obN𖾎IɌĂяo܂B {Iɂ͗pȂłAڑOɑSĂ̕ύXjꍇɌĂяo܂B
	 */
	public void rollback() throws SQLException {
		DBConnection.currentConnection().rollback();
	}

	/**
	 * DBANZXIāAconnectionv[ɖ߂܂B Icommit܂B
	 * 
	 * @throws Exception
	 */
	public void finish() throws Exception {
		// log("DBConnector.finish(): DBRlNVI܂");
		try {
			if (!DBConnection.currentConnection().getAutoCommit()) {
				// I[gR~bgItȂ炱ŃR~bg܂B
				DBConnection.currentConnection().commit();
			}

			if (statement != null) {
				// log("DBConnector.finish(): vyAhXe[ggؒf܂");
				statement.close();
				statement = null;
			}
			if (rs != null) {
				// log("DBConnector.finish(): UgZbgؒf܂");
				rs.close();
				rs = null;
			}
		} catch (Exception e) {
			throw e;
		} finally {
			// log("DBConnector.finish(): DBRlNV͐ؒf܂");
			// currentConnection().close();
		}
	}

	/**
	 * Oo͂郁\bhłB
	 * 
	 * @param content
	 */
	protected static void log(String content) {
		/*
		 * if (!WATCH) return; //WATCHfalseisԂȂjȉ͎̏s܂
		 */
		if (context != null) {
			context.log(content);
		} else {
			System.out.println(content);
		}

	}
}
