/**
 * IRCDynaValidatorForm.java
 *
 * Copyright (c) 2002 Boxed-Economy Project. All right reserved. 
 */
package freedom.server;

import java.util.Iterator;
import java.util.StringTokenizer;

import org.apache.struts.action.ActionMapping;
import org.apache.struts.validator.DynaValidatorForm;

/**
 * DynaValidatorFormgFormłB Ȃg邩łAForm͂ꂽ̒ɃVONH[gi'j܂܂Ă
 * ꍇɁAuȂƂcaɐo^Ȃ߂łB Struts̃tH[ł͂ʓIɍsȂ@\͓ڂĂȂ߁Â悤Ɋg
 * 𓾂܂łB
 * 
 * @author rx78g
 * @version $Id: FreedomDynaValidatorForm.java,v 1.2 2006/07/13 08:10:26 ikumi
 *          Exp $
 */
public class FreedomDynaValidatorForm extends DynaValidatorForm {

	private static final long serialVersionUID = 1L;
	private static final int NUMBER_OF_LINE = 40; // s̕
	private static final String BREAK_LINE = System
			.getProperty("line.separator");
	private boolean noLineFeed = false; // trueɂĂƉs}Ȃ

	/**
	 * @see org.apache.commons.beanutils.DynaBean#get(String)
	 */

	public Object get(String arg0) {
		Object o = super.get(arg0);
		if ((o instanceof String)) {
			o = replaceBackSlash((String) o);
			o = replaceSingleQuote((String) o);
		}
		return o;
	}

	/**
	 * 40(NUMBER_OF_LINEp[^[)Ƃɉss߂̃\bhłB 1xss2x͍s܂B
	 */
	public void lineFeed() {
		if (noLineFeed)
			return;
		Iterator i = getMap().keySet().iterator();
		while (i.hasNext()) {
			String s = (String) i.next();
			Object v = get(s);
			if (v instanceof String) {
				String vw = insertNewLine((String) v);
				set(s, vw);
			}
		}
		noLineFeed = true; // 1xs2xȂ
	}

	/**
	 * u'vu\'vɒu܂B
	 */
	private String replaceSingleQuote(String t) {
		// String t1 = winReplace(t, "'", "&&&&");
		// return winReplace(t1, "&&&&", "\\'");
		return t.replaceAll("\\\\*'", "\\\\'"); // \̐Ɋ֌WȂ\'ɒu
	}

	/**
	 * u\vu\\vɒu܂B
	 */
	private String replaceBackSlash(String t) {
		String t1 = winReplace(t, "\\", "&&&&");
		return winReplace(t1, "&&&&", "\\\\");
	}

	/**
	 * ̒usȂ\bh(WIN痬p)
	 */
	private String winReplace(String target, String bef, String af) {
		while (target.indexOf(bef) != -1) {
			target = target.substring(0, target.indexOf(bef)) + af
					+ target.substring(target.indexOf(bef) + bef.length());
		}
		return target;
	}

	/**
	 * Ɉ蕶Ƃɉs܂BCAEĝ߂̏Ȃ̂ŁAɊɉs܂܂ ꍇ́ÃJEgZbg܂B
	 * ܂Apłu>vsɂĂꍇ́AɉssĂƍlĂ̍sỉs܂Łj sǉ܂B
	 * 
	 * @param string
	 * @return
	 */
	private String insertNewLine(String target) {
		StringTokenizer strTokenizer = new StringTokenizer(target, BREAK_LINE,
				true);
		String nextStr = "";
		StringBuffer newBuff = new StringBuffer();

		// sƂɂg[Nɂꂼꏈs
		while (strTokenizer.hasMoreTokens()) {
			nextStr = strTokenizer.nextToken();

			// g[N40𒴂Ă邠41(ŏ̎_ς41A82)ɉs}
			while (nextStr.length() > NUMBER_OF_LINE
					&& !nextStr.startsWith(">")) {
				newBuff.append(nextStr.substring(0, NUMBER_OF_LINE)
						+ BREAK_LINE);
				nextStr = nextStr.substring(NUMBER_OF_LINE);
			}

			newBuff.append(nextStr);
		}

		return new String(newBuff);
	}

	public static void main(String[] args) {
		String s = "123456789012345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567890-end";
		System.out.print(s);
		System.out.println();
		System.out.println();
		FreedomDynaValidatorForm f = new FreedomDynaValidatorForm();
		System.out.println(f.insertNewLine(s));
	}
	/*
	 * (non-Javadoc)
	 * 
	 * @see org.apache.struts.action.DynaActionForm#initialize(org.apache.struts.action.ActionMapping)
	 */
	public void initialize(ActionMapping arg0) {
		noLineFeed = false;
		super.initialize(arg0);
	}

}
