package freedom.struts.event.action;

import java.util.Calendar;
import java.util.Date;
import java.util.Timer;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import org.apache.struts.action.Action;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;

import freedom.mail.FreedomMail;
import freedom.server.FreedomConfig;
import freedom.server.model.Event;
import freedom.server.transaction.EventManager;

public class CancelEventAction extends Action {
	public ActionForward execute(ActionMapping mapping, ActionForm actionForm,
			HttpServletRequest request, HttpServletResponse response)
			throws Exception {
		EventManager eventManager = new EventManager();

		HttpSession session = request.getSession();
		int eventID = Integer.parseInt(session.getAttribute("eventID")
				.toString()); // CxgID

		Calendar cal = Calendar.getInstance();
		cal.add(Calendar.DATE, 7);
		Date date = cal.getTime();

		// CxgLZ
		eventManager.cancel(eventID, date);

		Calendar cal2 = Calendar.getInstance();
		cal2.add(Calendar.DATE, 1);
		cal2.set(Calendar.HOUR_OF_DAY, 0);
		cal2.set(Calendar.MINUTE, 0);

		Timer timer = new Timer();
		System.out.println("** New Thread **");
		timer.scheduleAtFixedRate(new DeleteEventThread(eventID, date), cal2
				.getTime(), 1000 * 60 * 60 * 60 * 24);

		Event event = eventManager.getEvent(eventID);

		// ɃCxg~[𑗐M
		String hostMailAddress = event.getHostAddress();
		String hostMailTitle = "u" + event.getName() + "v𒆎~܂B";
		String hostMailContent = "Cxgu" + event.getName() + "v𒆎~܂B\n\r"
				+ "CxgĊJɂ́Apj[ʂCxgĊJNbNĂB\n\r"
				+ FreedomConfig.BASE_URL + "hostMenu.do?eventID=" + eventID
				+ "\n\r" + "7ȓɃCxgĊJȂꍇ́ACxgSɍ폜܂B";
		FreedomMail.sendMail(hostMailAddress, hostMailTitle, hostMailContent,
				false);

		// Q\҂ɃCxg~[𑗐M
		String[] separatedAddress = event.getParticipantAddress().split(
				FreedomConfig.ADDRESS_SEPARATOR);
		for (int i = 0; i < separatedAddress.length; i++) {
			String participantMailAddress = separatedAddress[i].trim();
			if (!participantMailAddress.equals("")) {
				System.out.println("CancelEvent: " + participantMailAddress);
				String participantMailTitle = "u" + event.getName()
						+ "v~܂B";
				String participantMailContent = "Cxgu" + event.getName()
						+ "v~܂B\n\rCxgĊJ܂ŁA\͂oo^łȂȂ܂B\n\r"
						+ "ւ̎Eӌ̑ḾA\ꗗʂs܂B\n\r"
						+ FreedomConfig.BASE_URL + "scheduleList.do?eventID="
						+ eventID + "&address=" + participantMailAddress;
				FreedomMail.sendMail(participantMailAddress,
						participantMailTitle, participantMailContent, false);
			}
		}

		request.setAttribute("event", event);
		return mapping.findForward("success");
	}
}
