package freedom.struts.event.action;

import java.util.Date;
import java.util.TimerTask;

import freedom.server.transaction.EventManager;

/**
 * Cxg~7ɃCxg폜NX
 * 
 * @author mab
 * 
 */
public class DeleteEventThread extends TimerTask {
	int eventId;
	Date deadline;

	public DeleteEventThread(int eventId, Date deadline) {
		this.eventId = eventId;
		this.deadline = deadline;
	}

	public void run() {
		System.out.println("** running *****");

		EventManager eventManager = new EventManager();

		if (deadline.getTime() < System.currentTimeMillis() && isCancel()) {
			try {
				eventManager.delete(eventId);
				System.out.println("DELETE!");
			} catch (Exception e) {
				e.printStackTrace();
			}
		}

		System.out.println("** Dead ********");
	}

	public boolean isCancel() {
		EventManager eventManager = new EventManager();
		boolean isCancel = false;
		try {
			isCancel = eventManager.getIsCancel(eventId);
		} catch (Exception e) {
			e.printStackTrace();
		}

		return isCancel;
	}
}
