package freedom.struts.event.action;

import java.lang.reflect.Array;
import java.sql.Date;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.List;
//import java.util.Date;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.struts.action.Action;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.action.DynaActionForm;

import freedom.mail.FreedomMail;
import freedom.server.FreedomConfig;
import freedom.server.model.Day;
import freedom.server.model.Event;
import freedom.server.model.Term;
import freedom.server.transaction.DayManager;
import freedom.server.transaction.EventManager;
import freedom.server.transaction.ParticipantManager;
import freedom.server.transaction.ScheduleManager;
import freedom.server.transaction.TermManager;

public class RegistChangeEventAction extends Action {
	public ActionForward execute(ActionMapping mapping, ActionForm actionForm,
			HttpServletRequest request, HttpServletResponse response)
			throws Exception {

		int eventID = Integer.parseInt(request.getSession().getAttribute(
				"eventID").toString());

		DynaActionForm daf = (DynaActionForm) actionForm;
		EventManager eventManager = new EventManager();
		DayManager dayManager = new DayManager();
		TermManager termManager = new TermManager();
		ScheduleManager scheduleManager = new ScheduleManager();
		ParticipantManager participantManager = new ParticipantManager();
		Calendar cal = Calendar.getInstance();

		Event e = eventManager.getEvent(eventID);
		request.setAttribute("event", e);

		if (!e.getIsCancel()) {
			// 񓚊Date^ɕϊ
			Date limit = Date.valueOf(String.valueOf(cal.get(Calendar.YEAR))
					+ "-" + daf.get("monthLimit") + "-" + daf.get("dayLimit"));
			System.out.println(limit);

			// Cxg𐶐
			Event event = new Event(Integer.parseInt(daf.get("eventID")
					.toString()), daf.getString("name"), daf
					.getString("outline"), Integer.parseInt(daf.get(
					"requiredDays").toString()), Integer.parseInt(daf.get(
					"requiredHours").toString()), Integer.parseInt(daf.get(
					"requiredMinutes").toString()), limit, daf
					.getString("hostName"), daf.getString("hostAddress"), daf
					.getString("participantAddress"));

			// f[^x[X̃CxgXV
			eventManager.update(event);

			List newDateList = new ArrayList(); // ύX̌
			List oldDayList = dayManager.getDayList(event.getId()); // ύXǑ
			List unchangedDayList = new ArrayList(); // ύXςȂ

			// ύX̌擾
			for (int i = 0; i < Array.getLength(daf.get("candidateDay")); i++) {
				String canDay = daf.get("candidateDay", i).toString();
				SimpleDateFormat sdf = new SimpleDateFormat("yyyy/MM/dd");
				java.util.Date date = sdf.parse(canDay);
				newDateList.add(date);
			}

			// DBɓo^V
			List registDateList = new ArrayList(); // ύXǑɂȂV
			for (int i = 0; i < newDateList.size(); i++) {
				boolean match = false;
				for (int j = 0; j < oldDayList.size(); j++) {
					Day oldDay = (Day) oldDayList.get(j);
					if (oldDay.getDate().equals(newDateList.get(i))) {
						match = true;
					}
				}
				if (match == false) {
					registDateList.add(newDateList.get(i));
				}
			}

			// DBɍ폜
			List deleteDateList = new ArrayList(); // ύXɂȂȂ
			for (int j = 0; j < oldDayList.size(); j++) {
				boolean match = false;
				Day oldDay = (Day) oldDayList.get(j);

				for (int i = 0; i < newDateList.size(); i++) {
					if (oldDay.getDate().equals(newDateList.get(i))) {
						System.out.println(i + "true");
						match = true;
					} else {
						System.out.println(i + "false");
					}
				}

				if (match == false) {
					deleteDateList.add(oldDay.getDate());
				} else {
					unchangedDayList.add(oldDay);
				}
			}

			// Vo^
			List newDayIdList = dayManager.register(event.getId(),
					registDateList);
			// ύXĂȂȂ폜
			dayManager.deleteDays(event.getId(), deleteDateList);

			// ύX̌⎞Ԃ̃Xg
			int newStartH = Integer.parseInt(daf.get("candidateBeginningHour")
					.toString());
			int newStartM = Integer.parseInt(daf
					.get("candidateBeginningMinute").toString());
			int newEndH = Integer.parseInt(daf.get("candidateEndingHour")
					.toString());
			int newEndM = Integer.parseInt(daf.get("candidateEndingMinute")
					.toString());

			List newTermList = makeTermList(newStartH, newStartM, newEndH,
					newEndM);

			// ύX̌⎞Ԃo^
			termManager.register(newTermList, newDayIdList);

			if (!unchangedDayList.isEmpty()) { // ύXςȂ
				Day oldDay = (Day) oldDayList.get(0);
				List oldTermList = oldDay.getTerm();
				Term firstTerm = (Term) oldTermList.get(0);
				Term lastTerm = (Term) oldTermList.get(oldTermList.size() - 1);

				int oldStartH = firstTerm.getStartHour();
				int oldStartM = firstTerm.getStartMinute();
				int oldEndH = lastTerm.getEndHour();
				int oldEndM = lastTerm.getEndMinute();

				// ύXςȂID𒊏o
				List unchangedDayIdList = new ArrayList();
				for (int i = 0; i < unchangedDayList.size(); i++) {
					Day d = (Day) unchangedDayList.get(i);
					unchangedDayIdList.add(new Integer(d.getID()));
				}

				// ⎞ԂdȂĂȂ
				if ((oldStartH >= newEndH && oldStartM >= newEndM)
						|| (newStartH >= oldEndH && newStartM >= oldEndM)) {
					// ςȂ̌⎞ԂS
					termManager.delete(oldTermList, unchangedDayIdList);
					// ςȂɐV⎞ԂSo^
					termManager.register(newTermList, unchangedDayIdList);

				} else {// ⎞ԂdȂĂ
					// ύX̊Jn⎞Ԃ̂قx
					if ((newStartH - oldStartH > 0)
							|| (newStartH - oldStartH == 0 && newStartM
									- oldStartM > 0)) {
						List marginTermList = makeTermList(oldStartH,
								oldStartM, newStartH, newStartM);
						termManager.delete(marginTermList, unchangedDayIdList);

					} // ύX̊Jn⎞Ԃ̂ق,
					else if ((newStartH - oldStartH < 0)
							|| (newStartH - oldStartH == 0 && newStartM
									- oldStartM < 0)) {
						List marginTermList = makeTermList(newStartH,
								newStartM, oldStartH, oldStartM);
						termManager
								.register(marginTermList, unchangedDayIdList);
					}

					// ύX̏I⎞Ԃ̂قx
					if ((newEndH - oldEndH > 0)
							|| (newEndH - oldEndH == 0 && newEndM - oldEndM > 0)) {
						List marginTermList = makeTermList(oldEndH, oldEndM,
								newEndH, newEndM);
						termManager
								.register(marginTermList, unchangedDayIdList);

					} // ύX̊Jn⎞Ԃ̂ق
					else if ((newEndH - oldEndH < 0)
							|| (newEndH - oldEndH == 0 && newEndM - oldEndM < 0)) {
						List marginTermList = makeTermList(newEndH, newEndM,
								oldEndH, oldEndM);
						termManager.delete(marginTermList, unchangedDayIdList);
					}
				}
			}

			// Ƀ[𑗂
			String hostMailTitle = "u" + daf.getString("name") + "v̓eύX܂";
			String hostMailContent = "ȉ̂悤ɃCxgeύX܂\n\r" + "Cxg:"
					+ daf.getString("name") + "\n\r" + ":"
					+ daf.getString("hostName") + "\n\r" + "Tv:"
					+ daf.getString("outline") + "\n\r" + "Kv:"
					+ daf.get("requiredDays") + "\n\r" + "Kv:"
					+ daf.get("requiredHours") + ""
					+ daf.get("requiredMinutes") + "\n\r" + "񓚊:" + limit
					+ "\n\r" + "̃AhX犲pj[ʂ֍s܂B\n\r"
					+ FreedomConfig.BASE_URL + "hostMenu.do?eventID="
					+ event.getId();
			FreedomMail.sendMail(daf.getString("hostAddress"), hostMailTitle,
					hostMailContent, false);

			// Q\҂Ƀ[𑗂
			String[] participantAddresses = daf.getString("participantAddress")
					.split("\n");
			String participantMailTitle = "u" + daf.getString("name")
					+ "v̓eύX܂";
			for (int i = 0; i < participantAddresses.length; i++) {
				String participantMailAddress = participantAddresses[i].trim();
				if (!participantMailAddress.equals("")) {
					String participantMailContent = ("Cxg:"
							+ daf.getString("name") + "\n\r" + ":"
							+ daf.getString("hostName") + "\n\r" + "Tv:"
							+ daf.getString("outline") + "\n\r" + "Kv:"
							+ daf.get("requiredDays") + "\n\r" + "Kv:"
							+ daf.get("requiredHours") + ""
							+ daf.get("requiredMinutes") + "\n\r" + "񓚊:"
							+ limit + "\n\r"
							+ "̃AhXQ\җpj[ʂ֍sė\LĂB\n\r"
							+ FreedomConfig.BASE_URL
							+ "scheduleList.do?eventID=" + event.getId()
							+ "&address=" + participantMailAddress);
					FreedomMail
							.sendMail(participantMailAddress,
									participantMailTitle,
									participantMailContent, false);
					if (participantManager.getParticipant(
							participantMailAddress, eventID) == null) {
						participantManager.registParticipant(
								participantMailAddress, eventID);
					}
					scheduleManager.registSchedule(participantMailAddress,
							eventID);
				}
			}
			return mapping.findForward("success");
		} else {
			return mapping.findForward("fail");
		}
	}

	/**
	 * ⎞ԃXg
	 */
	public List makeTermList(int startH, int startM, int endH, int endM) {
		List termList = new ArrayList();
		int nextH, nextM;

		while (startH != endH || startM != endM) {
			if (startM == 0) {
				nextH = startH;
				nextM = 30;
			} else {
				nextH = startH + 1;
				nextM = 0;
			}
			System.out.println(startH + ":" + startM + "," + nextH + ":"
					+ nextM);
			Term term = new Term(startH, startM, nextH, nextM);
			termList.add(term);
			startH = nextH;
			startM = nextM;
		}
		return termList;
	}

}
