package freedom.struts.event.action;

import java.util.Calendar;
import java.util.Date;
import java.util.TimerTask;

import freedom.mail.FreedomMail;
import freedom.server.FreedomConfig;
import freedom.server.model.Event;
import freedom.server.transaction.EventManager;

/**
 * 񓚊̈Oɗ\Q҂Ƀ}Ch[𑗂NX
 * 
 * @author mab
 * 
 */
public class RemindInputThread extends TimerTask {
	int eventId;

	public RemindInputThread(int eventId) {
		this.eventId = eventId;
	}

	public void run() {
		System.out.println("** running *****");
		EventManager eventManager = new EventManager();

		if (isReplyDeadline()) {
			try {
				Event event = eventManager.getEvent(eventId);
				String mailContent = ("Cxgu" + event.getName()
						+ "v̉񓚊łB\n\r" + "܂\͂ĂȂ͑͂ĂB\n\r"
						+ "Cxg:" + event.getName() + "\n\r" + ":"
						+ event.getHostName() + "\n\r" + "Tv:"
						+ event.getOutline() + "\n\r" + "Kv:"
						+ event.getRequiredDays() + "\n\r" + "Kv:"
						+ event.getRequiredHours() + ""
						+ event.getRequiredMinutes() + "\n\r" + "񓚊:"
						+ event.getReplyDeadline() + "\n\r"
						+ "̃AhXQ\җpj[ʂ֍sė\łB\n\r"
						+ FreedomConfig.BASE_URL + "scheduleList.do?eventID=" + eventId);
				FreedomMail.sendMail(event.getParticipantAddress(), event
						.getName()
						+ "̉񓚊̂m点", mailContent, false);
				cancel();
			} catch (Exception e) {
				e.printStackTrace();
			}
		}
		System.out.println("** Dead ********");
	}
	/**
	 * 񓚊̈O肷
	 * 
	 * @return
	 */
	public boolean isReplyDeadline() {
		EventManager eventManager = new EventManager();
		Calendar cal = Calendar.getInstance();
		Date deadline = null;
		try {
			deadline = eventManager.getReplyDeadline(eventId);
			cal.setTime(deadline);
			cal.add(Calendar.DATE, -1);
		} catch (Exception e) {
			e.printStackTrace();
		}
		return System.currentTimeMillis() > cal.getTimeInMillis();
	}
}
