package freedom.struts.event.action;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import org.apache.struts.action.Action;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;

import freedom.mail.FreedomMail;
import freedom.server.FreedomConfig;
import freedom.server.model.Event;
import freedom.server.transaction.EventManager;

public class RevivalEventAction extends Action {
	public ActionForward execute(ActionMapping mapping, ActionForm actionForm,
			HttpServletRequest request, HttpServletResponse response)
			throws Exception {
		HttpSession session = request.getSession();
		int eventID = Integer.parseInt(session.getAttribute("eventID")
				.toString()); // CxgID

		EventManager eventManager = new EventManager();

		// CxgĐ
		eventManager.revival(eventID);

		Event event = eventManager.getEvent(eventID);

		// ɃCxgĊJ[𑗐M
		String hostMailAddress = event.getHostAddress();
		String hostMailTitle = "u" + event.getName() + "vĊJ܂B";
		String hostMailContent = "Cxgu" + event.getName() + "vĊJ܂B\n\r"
				+ "j[ʂe푀sĂB\n\r" + FreedomConfig.BASE_URL
				+ "hostMenu.do?eventID=" + eventID;
		FreedomMail.sendMail(hostMailAddress, hostMailTitle, hostMailContent,
				false);

		// Q\҂ɃCxgĊJ[𑗐M
		String[] separatedAddress = event.getParticipantAddress().split(
				FreedomConfig.ADDRESS_SEPARATOR);
		for (int i = 0; i < separatedAddress.length; i++) {
			String participantMailAddress = separatedAddress[i].trim();
			if (!participantMailAddress.equals("")) {
				String participantMailTitle = "u" + event.getName()
						+ "vĊJ܂B";
				String participantMailContent = "Cxgu"
						+ event.getName()
						+ "vĊJ܂B\n\r\ꗗʂ\͂oo^ł悤ɂȂ܂̂ŁAL̍ڂ΋LĂB\n\r"
						+ FreedomConfig.BASE_URL + "scheduleList.do?eventID="
						+ eventID + "&address=" + participantMailAddress;
				FreedomMail.sendMail(participantMailAddress,
						participantMailTitle, participantMailContent, false);
			}
		}

		return mapping.findForward("success");
	}
}
