package freedom.struts.participant.action;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.struts.action.Action;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.action.DynaActionForm;

import freedom.mail.FreedomMail;
import freedom.server.model.Event;
import freedom.server.transaction.EventManager;

public class RegistQuestionAction extends Action {
	public ActionForward execute(ActionMapping mapping, ActionForm actionForm,
			HttpServletRequest request, HttpServletResponse response)
			throws Exception {
		DynaActionForm form = (DynaActionForm) actionForm;
		int eventID = Integer.parseInt(request.getSession().getAttribute(
				"eventID").toString());

		EventManager eventManager = new EventManager();
		Event event = eventManager.getEvent(eventID);

		String participantName = form.getString("name");
		String message = form.getString("message");
		String participantMailAddress = request.getSession().getAttribute(
				"mailAddress").toString();

		// ɖ₢킹[𑗐M
		String hostMailTitle = participantName + "񂩂̃bZ[W͂܂";
		String hostMailContent = participantName
				+ "񂩂ȉ̂悤ȃbZ[W܂B\n\r" + message + "\n\r"
				+ participantName + "ւ̕ԐḾA" + participantMailAddress
				+ "łB";
		FreedomMail.sendMail(event.getHostAddress(), hostMailTitle,
				hostMailContent, false);

		// Q\҂ɍT[𑗐M
		String participantMailTitle = "ɎEӌ𑗐M܂";
		String participantMailContent = "ȉ̓eŊɃ[𑗐M܂B\n\r" + message;
		FreedomMail.sendMail(participantMailAddress, participantMailTitle,
				participantMailContent, false);

		return mapping.findForward("success");
	}
}
