package freedom.struts.participant.action;

import java.util.Iterator;
import java.util.List;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.struts.action.Action;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;

import freedom.server.model.Day;
import freedom.server.model.Event;
import freedom.server.model.Participant;
import freedom.server.model.Term;
import freedom.server.transaction.DayManager;
import freedom.server.transaction.EventManager;
import freedom.server.transaction.ParticipantManager;
import freedom.server.transaction.ScheduleManager;
import freedom.server.transaction.TermManager;

public class ScheduleListAction extends Action {
	public ActionForward execute(ActionMapping mapping, ActionForm actionForm,
			HttpServletRequest request, HttpServletResponse response)
			throws Exception {
		int eventID;
		String mailAddress;
		int userID;

		// }l[W֘A
		EventManager eventManager = new EventManager();
		ParticipantManager participantManager = new ParticipantManager();
		DayManager dayManager = new DayManager();
		TermManager termManager = new TermManager();
		ScheduleManager scheduleManager = new ScheduleManager();

		/* Q\ID擾 */
		if (request.getParameter("userID") != null) {
			userID = Integer.parseInt(request.getParameter("userID"));
			System.out.println(userID);
		} else {
			/* Q\IDȂꍇio^j */
			userID = 0;
			System.out.println("First Impact!");
		}

		if (request.getParameter("address") != null) {
			mailAddress = request.getParameter("address").toString();
			System.out.println("ScheduleListAction: request:" + mailAddress);
		} else if (request.getSession().getAttribute("mailAddress") != null) {
			mailAddress = request.getSession().getAttribute("mailAddress")
					.toString();
			System.out.println("ScheduleListAction: session:" + mailAddress);
		} else {
			/* Q\IDȂꍇio^j */
			mailAddress = "";
			System.out.println("ScheduleListAction: addressNull:");
		}

		/* CxgID擾 */
		if (request.getParameter("eventID") != null) {
			eventID = Integer.parseInt(request.getParameter("eventID"));
			System.out.println("ScheduleListAction: session:" + eventID);
		} else if (request.getSession().getAttribute("eventID") != null) {
			eventID = Integer.parseInt(request.getSession().getAttribute(
					"eventID").toString());
			System.out.println("ScheduleListAction: session:" + eventID);
		} else {
			/* CxgIDȂꍇi̊ԈႢEEj */
			eventID = -1;
			System.out.println("eventID errorrr!");
		}

		Event event = eventManager.getEvent(eventID);

		List participantList = participantManager.getParticipantList(eventID);
		List dayList = dayManager.getDayList(eventID);
		List termList = termManager.getTermList(((Day) dayList.get(0)).getID());
		List scheduleList = scheduleManager.getScheduleList(eventID);
		List definedDayList = dayManager.getDefinedDayList(eventID);
		Term definedTerm = termManager.getDefinedTerm(definedDayList);

		boolean isDefined;
		if (definedDayList.size() > 0) {
			isDefined = true;
		} else {
			isDefined = false;
		}

		// Q\҂̐l߂
		int participantNumber = 0;
		for (Iterator ite = participantList.iterator(); ite.hasNext();) {
			Participant participant = (Participant) ite.next();
			if (participant.getIsParticipate() == true) {
				participantNumber++;
			}
		}

		request.setAttribute("event", event);
		request.setAttribute("participantList", participantList);
		request.setAttribute("userID", new Integer(userID));
		request.setAttribute("dayList", dayList);
		request.setAttribute("termList", termList);
		request.setAttribute("scheduleList", scheduleList);
		request.setAttribute("mailAddress", mailAddress);
		request.setAttribute("definedDayList", definedDayList);
		request.setAttribute("definedTerm", definedTerm);
		request.setAttribute("participantNumber", String
				.valueOf(participantNumber));
		request.setAttribute("isDefined", new Boolean(isDefined));

		request.getSession().setAttribute("eventID", new Integer(eventID));
		request.getSession().setAttribute("userID", new Integer(userID));
		request.getSession().setAttribute("mailAddress", mailAddress);
		return mapping.findForward("success");
	}
}
