package freedom.struts.schedule.action;

import java.lang.reflect.Array;
import java.util.ArrayList;
import java.util.List;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.struts.action.Action;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.action.DynaActionForm;

import freedom.server.model.Event;
import freedom.server.transaction.EventManager;

public class ConfirmDecideScheduleAction extends Action {
	public ActionForward execute(ActionMapping mapping, ActionForm actionForm,
			HttpServletRequest request, HttpServletResponse response)
			throws Exception {
		DynaActionForm form = (DynaActionForm) actionForm;
		int eventID = Integer.parseInt(form.get("eventID").toString());
		if (form.get("definedDay") != null) {
			List definedDay = new ArrayList();
			for (int i = 0; i < Array.getLength(form.get("definedDay")); i++) {
				definedDay.add(form.get("definedDay", i).toString());
			}

			EventManager eventManager = new EventManager();
			Event event = eventManager.getEvent(eventID);

			Integer beginningHour = (Integer) form.get("beginningHour");
			Integer beginningMinute = (Integer) form.get("beginningMinute");
			for (int i = 0; i < Array.getLength(form.get("definedDay")); i++) {
				System.out.println(form.get("definedDay", i));
			}

			request.setAttribute("event", event);
			request.setAttribute("beginningHour", beginningHour);
			request.setAttribute("beginningMinute", beginningMinute);
			request.setAttribute("subjoinder", form.get("subjoinder"));
			request.setAttribute("definedDay", definedDay);
			return mapping.findForward("success");
		} else {
			request.setAttribute("isDefinedDayExist", "false");
			return mapping.findForward("fail");
		}
	}
}
